SystemOrganization addCategory: #Kozen!

Object subclass: #ARObject
	instanceVariableNames: 'value siteId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

ARObject subclass: #ARImage
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 11:20'!
accept: aVisitor

	aVisitor visitImage: self.
! !

!ARImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 11:17'!
image
	^ image! !

!ARImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 11:17'!
image: anObject
	image := anObject! !

ARImage subclass: #ARLinkedImage
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARLinkedImage methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 22:51'!
accept: aVisitor

	aVisitor visitLinkedImage: self! !

!ARLinkedImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:51'!
link
	^ link! !

!ARLinkedImage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:51'!
link: anObject
	link := anObject! !

ARObject subclass: #ARItem
	instanceVariableNames: 'name link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

ARItem subclass: #ARBlockItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARBlockItem commentStamp: 'StephaneDucasse 1/3/2012 23:00' prior: 0!
ARBlockItem is an item of a floating block. For example like on the right of my web page.!

!ARBlockItem methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 23:04'!
accept: aVisitor

	aVisitor visitRightBlockItem: self.
! !

!ARItem methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:59'!
link
	
	^ link! !

!ARItem methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:59'!
link: aName

	link := aName! !

!ARItem methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:59'!
name

	^ name! !

!ARItem methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:59'!
name:  aString

	name := aString! !

ARItem subclass: #ARMenuItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARMenuItem methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/2/2012 22:57'!
accept: aVisitor

	aVisitor visitMenuItem: self.
! !

ARObject subclass: #ARList
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

ARList subclass: #ARDivBlock
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARDivBlock commentStamp: 'StephaneDucasse 1/5/2012 22:15' prior: 0!
<div id="header">
	attribute = id 
	value = header
	
	and nested components
	
!

!ARDivBlock methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 11:19'!
accept: aVisitor

	aVisitor visitDivBlock: self.
! !

!ARDivBlock methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:11'!
attribute
	^ attribute! !

!ARDivBlock methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 1/3/2012 22:11'!
attribute: aString
	
	attribute := aString! !

!ARList methodsFor: 'elements' stamp: 'StephaneDucasse 1/3/2012 22:47'!
addElement: anElement

	elements add: anElement! !

!ARList methodsFor: 'elements' stamp: 'StephaneDucasse 1/3/2012 22:47'!
elements

	^ elements! !

!ARList methodsFor: 'initialize' stamp: 'StephaneDucasse 1/3/2012 22:46'!
initialize

	super initialize.
	elements := OrderedCollection new.! !

ARList subclass: #ARMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARMenu methodsFor: 'visit' stamp: 'StephaneDucasse 1/2/2012 22:56'!
accept: aVisitor

	aVisitor visitMenu: self.
! !

ARList subclass: #ARResearchTopic
	instanceVariableNames: 'text bibItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

ARList subclass: #ARRightBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARRightBlock methodsFor: 'visit' stamp: 'StephaneDucasse 1/3/2012 22:49'!
accept: aVisitor

	aVisitor visitRightBlock: self.! !

ARList subclass: #ARSection
	instanceVariableNames: 'title text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:18'!
accept: aVisitor

	aVisitor visitSection: self! !

!ARSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:12'!
text
	^ text! !

!ARSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:12'!
text: anObject
	text := anObject! !

!ARSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:12'!
title
	^ title! !

!ARSection methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 15:12'!
title: anObject
	title := anObject! !

!ARObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:47'!
accept: aVisitor
	! !

!ARObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 09:57'!
siteId
	^ siteId! !

!ARObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 09:57'!
siteId: anId
	"anId should uniquely identify the receiver"
	siteId := anId! !

!ARObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:09'!
value
	^ value! !

!ARObject methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:10'!
value: aString
	value := aString! !

ARObject subclass: #ARPage
	instanceVariableNames: 'title elements head name main site'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARPage commentStamp: 'sd 1/7/2012 16:57' prior: 0!
ARPage has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

ARPage should hide the fact that elements can be or not in main.
Elements should returns what it should.!

!ARPage methodsFor: 'visiting' stamp: 'StephaneDucasse 1/2/2012 22:57'!
accept: aVisitor

	aVisitor visitPage: self.
! !

!ARPage methodsFor: 'adding' stamp: 'StephaneDucasse 1/2/2012 21:54'!
addElement: anElement

	elements add: anElement.! !

!ARPage methodsFor: 'adding' stamp: 'StephaneDucasse 1/6/2012 14:34'!
addElementInMain: anElement

	main addElement: anElement.! !

!ARPage methodsFor: 'default' stamp: 'sd 1/7/2012 15:03'!
defaultHead

	^ '<head>
		<link rel="stylesheet" href="CSS/stef.css"/>
		<title>Dr. St&eacute;phane Ducasse</title>
   </head>'! !

!ARPage methodsFor: 'default' stamp: 'StephaneDucasse 1/2/2012 22:39'!
defaultName

	^ 'Home'! !

!ARPage methodsFor: 'default' stamp: 'sd 1/7/2012 15:03'!
defaultTitle

	^ 'Dr. St&eacute;phane Ducasse' ! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:54'!
elements

	^ elements! !

!ARPage methodsFor: 'visiting' stamp: 'sd 1/7/2012 08:30'!
filename
	
	| filename |
	filename := self name, '.html'.
	"does not work for file creation should use fs"
	"^ site ifNil: [filename] ifNotNil: [site folder, filename] "
	^ filename! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 21:53'!
head

	^ head! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/3/2012 22:26'!
headerPageTitle

	^ self name
! !

!ARPage methodsFor: 'accessing' stamp: 'sd 1/7/2012 15:06'!
headerSiteTitle

	^ 'St&eacute;phane Ducasse'! !

!ARPage methodsFor: 'initialize-release' stamp: 'StephaneDucasse 1/6/2012 14:26'!
initialize

	super initialize.
	elements := OrderedCollection new.
	head := self defaultHead.
	title := self defaultTitle.
	name := self defaultName.
	main := ARDivBlock new attribute: 'id' ; value: 'mainContent'.! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/6/2012 14:27'!
main
	"describes the main part of the body - related to css may be we should change that but 
	menu should be out and block and section nested in."
	
	^ main! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 21:52'!
metaHead

	^ '<?xml version="1.0" encoding="ISO-8859-1"?>
	<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">'! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:40'!
name 

	^ name! !

!ARPage methodsFor: 'accessing' stamp: 'StephaneDucasse 1/2/2012 22:40'!
name: aString
	name := aString! !

!ARPage methodsFor: 'accessing' stamp: 'sd 1/6/2012 22:19'!
site

	^ site! !

!ARPage methodsFor: 'accessing' stamp: 'sd 1/6/2012 22:20'!
site:  aSite

	site := aSite! !

Object subclass: #ARSite
	instanceVariableNames: 'elements pages folder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARSite methodsFor: 'initialize' stamp: 'sd 1/6/2012 22:03'!
addPage: aPage

	pages add: aPage! !

!ARSite methodsFor: 'operations' stamp: 'StephaneDucasse 1/6/2012 14:40'!
declare: anElement withId: anID

	elements at: anID put: anElement! !

!ARSite methodsFor: 'operations' stamp: 'sd 1/6/2012 22:28'!
declarePage: anElement withId: anID

	elements at: anID put: anElement.
	anElement site: self.
	pages add: anElement.! !

!ARSite methodsFor: 'initialize' stamp: 'sd 1/6/2012 22:14'!
filenameForPage: aPage
	^ folder, aPage name, '.html'! !

!ARSite methodsFor: 'operations' stamp: 'sd 1/6/2012 22:28'!
folder
	
	^ folder! !

!ARSite methodsFor: 'initialize' stamp: 'sd 1/6/2012 22:02'!
initialize

	super initialize.
	elements := Dictionary new.
	pages := OrderedCollection new.! !

!ARSite methodsFor: 'operations' stamp: 'sd 1/6/2012 22:25'!
pages
	^ pages! !

ARSite subclass: #StefSite
	instanceVariableNames: ''
	classVariableNames: 'CachedSiteSeer'
	poolDictionaries: ''
	category: 'Kozen'!

StefSite class
	instanceVariableNames: 'site menu page main'!

StefSite class
	instanceVariableNames: 'site menu page main'!

!StefSite class methodsFor: 'as yet unclassified' stamp: 'sd 1/7/2012 18:30'!
initialize

	CachedSiteSeer := true.! !

!StefSite methodsFor: 'texts' stamp: 'sd 1/7/2012 17:02'!
awardText

	^ '	<div class="itemizedlist"> 
      <ul type="disc">
	<li>Distinguished Visiting Fellowship Award of the Royal Academy of Engineering (2011).</li>
	<li>Veronica Uquillas Gomez won the Benevol most promising young research Award (2011).</li>
	<li>Mariano Martinez-Peck and Martin Diaz'' Fuel won the 2011 ESUG Technology Award. .</li>
	<li> <a href="http://books.seaside.st/">Dynamic web development with Seaside</a>: Our new free open-source Seaside book won the ESUG member 2010 best book Award.</li>
	  <li> Michele Lanza (2003) and Alexandre Bergel (2006) PhD theses won the <a href="http://www.denert-stiftung.de/">Ernest Denert foundation for Software Engineering</a> Award.</li>
	  
	  <li> <a href="http://rmod.lille.inria.fr/botsinc/pier">Learning Programming with Robots</a> received the Award of PCPlus magazine of September 2005 and the Bitwise Recommended Award in February 2006.
	  </ul>'
! !

!StefSite methodsFor: 'elements' stamp: 'StephaneDucasse 1/6/2012 10:02'!
block 

	| block |
	block := ARRightBlock new.
	block addElement: (ARImage new image: 'StefFingerOnNose128.jpg'; yourself).
	block addElement: (ARBlockItem new name: 'INRIA'; link: 'http://www.inria.fr/'; yourself).
	block addElement: (ARBlockItem new name: 'RMOD'; link: 'http://rmod.lille.inria.fr/'; yourself).
	block addElement: (ARBlockItem new name: 'Stephane-Ducasse(@)INRIA.FR'; link: 'mailto:stephane.ducasse@inria.fr'; yourself).
	self declare: block withId: #block.
	^ block
	! !

!StefSite methodsFor: 'texts' stamp: 'sd 1/7/2012 18:32'!
citeseerText
	
	|cite |
	cite := CachedSiteSeer 
				ifTrue: [self defaultSiteSeer]
				ifFalse: [(Citeseer rankOf: 'S. Ducasse')].
	^ 'According to <a href="http://citeseerx.ist.psu.edu/stats/authors">CiteSeer</a>, I''m at rank ', cite asString, ' of most cited computer scientists.'.  ! !

!StefSite methodsFor: 'operation' stamp: 'sd 1/6/2012 22:25'!
createSite
	"self new createSite"
	
	| visitor |
	visitor := ARVisitor new.
	visitor visitSite: self site.
	! !

!StefSite methodsFor: 'texts' stamp: 'StephaneDucasse 1/6/2012 15:40'!
currentJobText

	^ 'Since June 2011, I''m scientific officer of  <a HREF="http://www.inria.fr/centre-de-recherche-inria/lille-nord-europe">INRIA Lille Nord Europe research center</a>. Since September 2007, I''m research director at <a HREF="http://www.inria.fr">INRIA Lille</a> leading the <a href="http://rmod.lille.inria.fr">RMoD Team</a>. During 10 years, I co-directed with Oscar Nierstrasz the <A HREF="http://www.iam.unibe.ch/~scg"> Software Composition Group</a>. I was the leader of the <A HREF="http://www.iam.unibe.ch/~scg/Research/Recast/index.html">RECAST Project</a>.  I''m the president of <a HREF="http://www.esug.org/">ESUG</a>. Here is a short <a HREF="2011-CV.pdf">CV</a>.' ! !

!StefSite methodsFor: 'elements' stamp: 'sd 1/7/2012 18:28'!
defaultSiteSeer

	^ 3194! !

!StefSite methodsFor: 'texts' stamp: 'StephaneDucasse 1/6/2012 10:09'!
indexesText

	^ 'According to google scholar my h-index is 41 and my g-index is 70 - Maximum Cites: 343.'
! !

!StefSite methodsFor: 'initialize' stamp: 'sd 1/7/2012 15:04'!
initialize
	super initialize.
	"does not work should use fs"
	folder := 'Site/'! !

!StefSite methodsFor: 'texts' stamp: 'StephaneDucasse 1/6/2012 10:06'!
keywordsText

	^ 'Software Engineering, Object-Oriented Programming, Language Design, Reengineering, Reverse Engineering, Program Understanding, Reflective Programming, Dynamically typed languages, Meta-Programming, MOP, Aspect-Oriented Programming, Modules, Frameworks, Design Patterns, Teaching OO, Traits, Classboxes, Scheme, Smalltalk, Java, C#.'
! !

!StefSite methodsFor: 'elements' stamp: 'sd 1/7/2012 16:17'!
menu

	| menu |
	menu := ARMenu new.
	menu addElement: (ARMenuItem new name: 'Home'; link: 'index.html'; yourself).
	menu addElement: (ARMenuItem new name: 'Publications'; link: 'Publications.html'; yourself).
	menu addElement: (ARMenuItem new name: 'Books'; link: 'Books.html'; yourself).
	menu addElement: (ARMenuItem new name: 'Free Smalltalk Books'; link: 'FreeBooks.html'; yourself).
	menu addElement: (ARMenuItem new name: 'Downloads/Resources'; link: 'Resources.html'; yourself).
	menu addElement: (ARMenuItem new name: 'Lectures'; link: 'Lectures.html'; yourself).
	menu addElement: (ARMenuItem new name: 'Coordinates'; link: 'Coordinates.html'; yourself).
	self declare: menu withId: #menu.
	^ menu 
	! !

!StefSite methodsFor: 'elements' stamp: 'sd 1/7/2012 17:09'!
sectionAwardsAndIndexes

	| section | 
	section := ARSection new title: 'Awards and Indexes'; text: self indexesText , ' ', self citeseerText,  (Character cr asString), self awardText.
	self declare: section withId: #awards.! !

!StefSite methodsFor: 'elements' stamp: 'StephaneDucasse 1/6/2012 15:13'!
sectionCurrentJob

	| section | 
	section := ARSection new title: 'Current responsibilities'; text: self currentJobText.
	self declare: section withId: #secCurrentJob.! !

!StefSite methodsFor: 'elements' stamp: 'sd 1/6/2012 22:12'!
site
	"self site"
	"in the future the complete web site here"
	
	self welcomePage.
	^ self.
	! !

!StefSite methodsFor: 'elements' stamp: 'sd 1/7/2012 16:28'!
welcomePage
	"self site"
	"in the future the complete web site here"
	
	| welcomePage |
	welcomePage := ARPage new.
	welcomePage name: 'index'.
	self declarePage: welcomePage withId: #welcomePage.
	self menu.
	self block.
	self sectionCurrentJob.
	self sectionAwardsAndIndexes.
	
	welcomePage addElement: (elements at: #menu).
	welcomePage addElementInMain: (elements at: #block).
	welcomePage addElementInMain: (elements at: #secCurrentJob).
	welcomePage addElementInMain: (elements at: #awards).
	^ welcomePage
	! !

Object subclass: #ARTodo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARTodo commentStamp: 'sd 1/7/2012 16:30' prior: 0!
to do
	- add long cv link
	- manage lists
	- convert all web site
	- manage news: show two from a list and on demand all
	- parse information from file instead of typing it in Smalltalk
	!

Object subclass: #ARVisitor
	instanceVariableNames: 'site stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!ARVisitor commentStamp: 'StephaneDucasse 1/1/2012 22:52' prior: 0!
ARVisitor is a web site visitor. !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:19'!
addComment: aComment
	stream 
		nextPutAll: '    <!!--'; 
		nextPutAll: aComment; 
		nextPutAll: ' -->'.
	! !

!ARVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:12'!
bodyEncodings
	^ 'body'! !

!ARVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/2/2012 22:19'!
contents

	^ stream contents! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:38'!
cr

	stream nextPut: Character cr! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:31'!
div

	self startBalise: 'div'! !

!ARVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:12'!
divEncodings
	^ 'div'! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:37'!
endBalise: aString

	stream nextPut: $< ; nextPut: $/.
	stream nextPutAll: aString.
	stream nextPut: $>. 
	

	! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 21:38'!
endBaliseCr: aString

	self endBalise: aString.
	self cr.
	

	! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:33'!
endBody

	self endBalise: 'body'.! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:32'!
endDiv

	self endBalise: 'div'! !

!ARVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/4/2012 13:12'!
ensureAttribute: aKey value: aTag div: aBlock
	"ensureDiv: aBlock key: id tagged: menu ->
		div id='menu'"

	self startBalise: self divEncodings attribute: aKey value: aTag.
	aBlock cull: stream.
	self endDiv.
	self addComment: 'Closing ' , aTag.
	self cr! !

!ARVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/4/2012 13:13'!
ensureBody: aBlock
	self startBalise: self bodyEncodings.
	aBlock cull: stream.
	self endBalise: self bodyEncodings! !

!ARVisitor methodsFor: 'operation' stamp: 'StephaneDucasse 1/3/2012 11:25'!
ensureDiv: aBlock
	
	self div.
	aBlock value: stream.
	self endDiv! !

!ARVisitor methodsFor: 'operation' stamp: 'sd 1/7/2012 16:36'!
ensureIdValue: aTag div: aBlock
	"ensureDiv: aBlock key: id tagged: menu ->
		div id='menu'"

	self startBalise: self divEncodings attribute: 'id' value: aTag.
	self cr.
	aBlock cull: stream.
	self endDiv.
	self addComment: 'Closing ' , aTag.
	! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:31'!
ensureTag: aString for: aBlock

	self startBalise: aString.
	aBlock value: stream.
	self endBalise: aString! !

!ARVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:14'!
headerEncodings
	^ 'header'! !

!ARVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:15'!
headerPageTitleEncodings
	^ 'headerPageTitle'! !

!ARVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:14'!
headerSideTitleEncodings
	^ 'headerSideTitle'! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/6/2012 14:36'!
href: url name: aString

	stream 
		nextPutAll: '<a href="';
		nextPutAll: url;
		nextPutAll: '">';
		nextPutAll: aString;
		nextPutAll: '</a>'! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:18'!
mainContentEncodings
	^ 'mainContent'! !

!ARVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:13'!
menuEncodings
	^ 'menu'! !

!ARVisitor methodsFor: 'visit' stamp: 'sd 1/6/2012 21:57'!
newFileFor: aPage
	^ FileStream forceNewFileNamed: aPage filename! !

!ARVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:15'!
personalDetailsEncodings
	^ 'personalDetails'! !

!ARVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 14:57'!
personalDetailsItemEncodings
	^ 'personalDetailsItem'! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:33'!
startBalise: aString

	stream nextPut: $<.
	stream nextPutAll: aString.
	stream nextPut: $>.
	stream nextPut: Character cr.

	! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 22:38'!
startBalise:  balise attribute: aKey value: aTag.
	
	stream 
		nextPut: $<; 
		nextPutAll: balise ; 
		nextPut: Character space ; 
		nextPutAll: aKey ; 
		nextPutAll: '="' ; 
		nextPutAll: aTag; 
		nextPutAll: '">'.! !

!ARVisitor methodsFor: 'private' stamp: 'StephaneDucasse 1/3/2012 11:33'!
startBody

	self startBalise: 'body'.! !

!ARVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:13'!
tocEncodings
	^ 'toc'! !

!ARVisitor methodsFor: 'default' stamp: 'StephaneDucasse 1/4/2012 13:14'!
tocItemEncodings
	^ 'tocItem'! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/2/2012 22:47'!
visit: anElement

	anElement accept: self! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:18'!
visitDivBlock: aBlock

	self
		ensureIdValue: self mainContentEncodings
		div: [ aBlock elements do: [ :each | self visit: each ] separatedBy: [ stream cr ] ]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/6/2012 14:39'!
visitImage: aLinkedImage

	self ensureDiv: [ :aStream | 
			aStream 
				nextPutAll: '<img src="'; nextPutAll: aLinkedImage image; 
				nextPutAll: '">' ; 
				nextPut: Character cr]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/6/2012 09:51'!
visitLinkedImage: anImage

	self ensureDiv: [ :aStream | 
			aStream 
				nextPutAll: '<a href="'; 
				nextPutAll: anImage link; 
				nextPutAll: '"><img src="'; nextPutAll: anImage image; 
				nextPutAll: '"></a>' ; 
				nextPut: Character cr]! !

!ARVisitor methodsFor: 'visit' stamp: 'sd 1/7/2012 16:53'!
visitMenu: aMenu
	self
		ensureIdValue: self menuEncodings
		div: [ 
			self
				ensureIdValue: self tocEncodings
				div: [ aMenu elements do: [ :each | self visit: each ] 
										separatedBy: [ stream cr ] ] ]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:11'!
visitMenuItem: aMenuItem
	self ensureIdValue: self tocItemEncodings div: [ self href: aMenuItem link name: aMenuItem name ]! !

!ARVisitor methodsFor: 'visit' stamp: 'sd 1/7/2012 16:59'!
visitPage: aPage
	
	[stream := self newFileFor: aPage.
	stream nextPutAll: aPage metaHead.
	stream nextPutAll: aPage head.
	self
		ensureBody: [ 
			self
				ensureIdValue: self headerEncodings
				div: [ 
					self ensureIdValue: self headerSideTitleEncodings div: [ stream nextPutAll: aPage headerSiteTitle ].
					self ensureIdValue: self headerPageTitleEncodings div: [ stream nextPutAll: aPage headerPageTitle ]].
			aPage elements do: [ :each | self visit: each ].
			self ensureIdValue: self mainContentEncodings div: [ 
					aPage main elements do: [ :each | self visit: each ]]			
			]]
		ensure: [stream close]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:12'!
visitRightBlock: aBlock
	self
		ensureIdValue: self personalDetailsEncodings
		div: [ aBlock elements do: [ :each | self visit: each ] separatedBy: [ stream cr ] ]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/5/2012 22:12'!
visitRightBlockItem: anItem
	self ensureIdValue: self personalDetailsItemEncodings div: [ self href: anItem link name: anItem name ]! !

!ARVisitor methodsFor: 'visit' stamp: 'StephaneDucasse 1/6/2012 15:18'!
visitSection: aSection

	stream nextPutAll:  '<h2><b><a NAME="', aSection title, '">',  aSection title, '</a></b></h2>'.
	stream nextPutAll:  aSection text.! !

!ARVisitor methodsFor: 'visit' stamp: 'sd 1/6/2012 22:15'!
visitSite: aSite

	aSite pages do: [:each | self visit: each].! !

Object subclass: #Citeseer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kozen'!

!Citeseer commentStamp: 'DamienCassou 1/6/2012 18:39' prior: 0!
Get the rank of someone in the Citeseer author's citation ranking (http://citeseerx.ist.psu.edu/stats/authors?all=true).

For example:

Citeseer rankOf: 'S. Ducasse'!

!Citeseer class methodsFor: 'public' stamp: 'DamienCassou 1/6/2012 18:37'!
rankOf: aName
	"self rankOf: 'S. Ducasse'"
	^ self new rankOf: aName! !

!Citeseer methodsFor: 'operation' stamp: 'DamienCassou 1/6/2012 18:23'!
getCiteseerPage
	^ ZnHttpClient new
		url: 'http://citeseerx.ist.psu.edu/stats/authors';
		parameterAt: 'all' put: 'true';
		get! !

!Citeseer methodsFor: 'operation' stamp: 'DamienCassou 1/6/2012 18:36'!
getRankFrom: page stoppingAt: aString
	| count |
	count := 0.
	page
		regex: '<li>[[:space:]]*<span class="authors">[^>]+>([^<]+)'
		matchesDo: [:match | (match matchesRegex: ('.*', aString, '$'))
								ifTrue: [^ count + 1]
								ifFalse: [count := count + 1]].
	^ Error signal: aString, ' not found in page'! !

!Citeseer methodsFor: 'operation' stamp: 'DamienCassou 1/6/2012 18:34'!
rankOf: aName
	| content rank |
	content := self getCiteseerPage.
	rank := self getRankFrom: content stoppingAt: aName.
	^ rank ! !

!String methodsFor: '*kozen' stamp: 'StephaneDucasse 1/6/2012 15:31'!
deDoubleSingleQuotes
	"transform two subsequent single quotes into one"
	
	"'abcdebcdg' . 'bc' .'z' ->  'azdezdg' but the same with '' and '"
	
	^ self copyReplaceAll: (String with: $' with: $')  with: (String with: $') 
	! !
StefSite initialize!
